#include <Arduino.h>
#include <Motor/Motor.h>
#include <constants.h>

using namespace constants;

Motor::Motor(int pin){
    _pinEnabled = pin;    
    pinMode(_pinEnabled, OUTPUT);
    _setEnabled(false);
}

void Motor::_defineRotation(Rotation s){
  if (s == clockwise)
    digitalWrite(PIN_DIRECTION, LOW);
  else
    digitalWrite(PIN_DIRECTION, HIGH);
}

void Motor::_setEnabled(bool value){
    if (value == true)
        digitalWrite(_pinEnabled, LOW);
    else
        digitalWrite(_pinEnabled, HIGH);
    _enabled = value;
}

void Motor::rotate(Rotation s, int turns){        
    _defineRotation(s);
    _setEnabled(true);    
    delay(35);
    //total steps = 200 per rotation
    int steps = (turns * 50) + 0;
    for (int x = 0; x < steps; x++){
      digitalWrite(PIN_STEPS, HIGH);
      delay(4);
      digitalWrite(PIN_STEPS, LOW);
      delay(6);
    }
    _setEnabled(false);
}